<?php
namespace Teknisa\CTB\Modules\Saldos\Controllers;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\CTB\Controllers\TeknisaCrud;
use Teknisa\CTB\Modules\Saldos\Services\Ctb44200RazaoGerencialService;
use Zeedhi\Framework\DataSource\DataSet;

class Ctb44200RazaoGerencialController extends TeknisaCrud{


    public function __construct($crudService, ParameterBag $parameterBag, Ctb44200RazaoGerencialService $service) {
        parent::__construct($crudService, $parameterBag);
        $this->service = $service;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        ini_set('memory_limit', '1024M');
        ini_set('max_execution_time', '14400');
        set_time_limit(14400);
        ini_set("defaut_socket_timeout", 0);
        
        $filter = $request->getFilterCriteria()->getConditions();
       
        $params = self::getParamsAsArray($filter);
        
        $data = $this->service->find($params);
        
           
        $response->addDataSet(new DataSet('razao_gerencial_exportar_novo', $data));
    }
    
    public function getParamsAsArray($filter) {
        $params = array();
        foreach($filter as $row){
            $params[$row['columnName']] = $row['value'];
        }
        return $params;
    }
    
}
