/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_REGIMEBEM                                                */
/* Tabela : REGIMEBEM                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 15/01/2009 - Frederico Gonalves Moreira da Costa                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE
TRIGGER DTULTATU_REGIMEBEM
BEFORE INSERT OR UPDATE OR DELETE
ON REGIMEBEM FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF(NVL(:OLD.CDEMPRESA    ,0) <> NVL(:NEW.CDEMPRESA    ,0)) OR
        (NVL(:OLD.CDREGIMEBEM  ,0) <> NVL(:NEW.CDREGIMEBEM  ,0)) OR
        (NVL(:OLD.NMREGIMEBEM  ,0) <> NVL(:NEW.NMREGIMEBEM  ,0)) OR
        (NVL(:OLD.NMABREVREGBEM,0) <> NVL(:NEW.NMABREVREGBEM,0)) OR
        (NVL(:OLD.IDDEPREGBEM  ,0) <> NVL(:NEW.IDDEPREGBEM  ,0)) THEN
         :NEW.DTULTATU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE,CDFILICACHE,DSKEYCACHE,DTULTATUCACH)
      VALUES ('REGIMEBEM','','CDEMPRESA='||:OLD.CDEMPRESA||';CDREGIMEBEM='||:OLD.CDREGIMEBEM||';',SYSDATE);
   END IF;
END;
/
ALTER TABLE REGIMEBEM MODIFY DTULTATU DEFAULT SYSDATE
/
UPDATE REGIMEBEM SET DTULTATU = SYSDATE WHERE DTULTATU IS NULL
/
-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_REGIMEBEM','5.05.119'); END;
/

