/* Teknisa - Tecnologia em Informtica

Nome: 3908_CDPFUNS_CUSTO_MPRIMAINSUMO.SQL

Descrio:
Funo para retornar o custo do produto (Mat. Prima/Insumo).

Criao:
17/05/2005 - Fabrcio Marcelo da Silva

@..\Sql\End_Conv\SqlServer\3908_CDPFUNS_CUSTO_MPRIMAINSUMO.SQL
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'CUSTO_MPRIMAINSUMO' AND
                 TYPE = 'FN' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP FUNCTION CUSTO_MPRIMAINSUMO
GO
CREATE FUNCTION CUSTO_MPRIMAINSUMO(
   @P_CDFILIAL      VARCHAR(4),
   @P_CDPRODUTO     VARCHAR(10),
   @P_CDPROCFABRIC  VARCHAR(10),
   @P_TIPOCUSTO     NUMERIC,
   @P_QTDE          FLOAT,
   @P_DTCUSTO       DATETIME) RETURNS FLOAT
AS
BEGIN
   DECLARE @V_VRCUSTMPRIMA  FLOAT;
   DECLARE @V_VRCUSTINSUMO  FLOAT;
   DECLARE @V_VRCUSTPROD    FLOAT;
   DECLARE @V_QTDE          FLOAT;
   DECLARE @V_COUNTSACAB    NUMERIC;
END
GO

ALTER FUNCTION CUSTO_MPRIMAINSUMO(
   @P_CDFILIAL      VARCHAR(4),
   @P_CDPRODUTO     VARCHAR(10),
   @P_CDPROCFABRIC  VARCHAR(10),
   @P_TIPOCUSTO     NUMERIC,
   @P_QTDE          FLOAT,
   @P_DTCUSTO       DATETIME) RETURNS FLOAT
AS
BEGIN
   DECLARE @V_VRCUSTMPRIMA  FLOAT;
   DECLARE @V_VRCUSTINSUMO  FLOAT;
   DECLARE @V_VRCUSTPROD    FLOAT;
   DECLARE @V_QTDE          FLOAT;
   DECLARE @V_COUNTSACAB    NUMERIC;

   DECLARE @C_SEMIACABADO_CDPRODUTO      VARCHAR(10);
   DECLARE @C_SEMIACABADO_CDPRODINSUMO   VARCHAR(10);
   DECLARE @C_SEMIACABADO_CDPROCFABRIC   VARCHAR(10);
   DECLARE @C_SEMIACABADO_IDPROFABPADR   VARCHAR(1);
   DECLARE @C_SEMIACABADO_QUANTIDADE     FLOAT;

   SET @V_VRCUSTMPRIMA = 0;
   SET @V_VRCUSTINSUMO = 0;
   SET @V_VRCUSTPROD   = 0;
   SET @V_COUNTSACAB   = 0;
   SET @V_QTDE         = @P_QTDE;

   IF @V_QTDE = 0 BEGIN
      SET @V_QTDE = 1; 
   END;
   /* Verifica semi-acabados */
   IF (NOT @P_CDPROCFABRIC IS NULL) BEGIN
      SELECT
         @V_COUNTSACAB = COUNT(I.CDPRODINSUMO)
      FROM
         INSUMETAPA I,
         PROCFABRICA P
      WHERE
         (I.CDFILIAL     = @P_CDFILIAL)     AND
         (I.CDPRODUTO    = @P_CDPRODUTO)    AND
         (I.CDPROCFABRIC = @P_CDPROCFABRIC) AND
         (I.IDSEMIACETAP = 'S')             AND
         (I.CDFILIAL     = P.CDFILIAL)      AND
         (I.CDPRODINSUMO = P.CDPRODUTO)     AND
         (P.IDPROFABPADR = 'S');

      IF @V_COUNTSACAB > 0 BEGIN

         DECLARE C_SEMIACABADO CURSOR FOR
            SELECT
               I.CDPRODUTO,
               I.CDPRODINSUMO,
               P.CDPROCFABRIC,
               P.IDPROFABPADR,
               TEKNISA.QTPREVI_MATPRIMA(@P_CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, @P_QTDE, 'S') AS QUANTIDADE
            FROM
               INSUMETAPA I,
               PROCFABRICA P
            WHERE
               (I.CDFILIAL     = @P_CDFILIAL)     AND
               (I.CDPRODUTO    = @P_CDPRODUTO)    AND
               (I.CDPROCFABRIC = @P_CDPROCFABRIC) AND
               (I.IDSEMIACETAP = 'S')             AND
               (I.CDFILIAL     = P.CDFILIAL)      AND
               (I.CDPRODINSUMO = P.CDPRODUTO)     AND
               (P.IDPROFABPADR = 'S');

         OPEN C_SEMIACABADO;
         FETCH NEXT FROM C_SEMIACABADO INTO @C_SEMIACABADO_CDPRODUTO, @C_SEMIACABADO_CDPRODINSUMO,
                                            @C_SEMIACABADO_CDPROCFABRIC, @C_SEMIACABADO_IDPROFABPADR, @C_SEMIACABADO_QUANTIDADE;

         WHILE (@@FETCH_STATUS = 0)
         BEGIN
            SET @V_COUNTSACAB = 0;

            SELECT
               @V_COUNTSACAB = COUNT(I.CDPRODINSUMO)
            FROM
               INSUMETAPA I,
               PROCFABRICA P
            WHERE
               (I.CDFILIAL     = @P_CDFILIAL)     AND
               (I.CDPRODUTO    = @P_CDPRODUTO)    AND
               (I.CDPROCFABRIC = @P_CDPROCFABRIC) AND
               (I.IDSEMIACETAP = 'S')             AND
               (I.CDFILIAL     = P.CDFILIAL)      AND
               (I.CDPRODINSUMO = P.CDPRODUTO)     AND
               (P.IDPROFABPADR = 'S');

            IF @V_COUNTSACAB > 0 BEGIN
               SET @V_VRCUSTMPRIMA = 0;

               SELECT
                  @V_VRCUSTMPRIMA = (SUM(TEKNISA.QTPREVI_MATPRIMA(@P_CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, @P_QTDE, 'S') *
                                     TEKNISA.CUSTO_PRODUTO(@P_CDFILIAL, I.CDPRODINSUMO, @P_TIPOCUSTO, @P_DTCUSTO, @P_DTCUSTO) / ISNULL(@V_QTDE,1)))
               FROM
                  INSUMETAPA I
               WHERE
                  (I.CDFILIAL     = @P_CDFILIAL)     AND
                  (I.CDPRODUTO    = @P_CDPRODUTO)    AND
                  (I.CDPROCFABRIC = @P_CDPROCFABRIC) AND
                  (ISNULL(I.IDSEMIACETAP,'N') <> 'S');

               SET @V_VRCUSTPROD = @V_VRCUSTPROD + @V_VRCUSTMPRIMA + (TEKNISA.CUSTO_MPRIMAINSUMO(@P_CDFILIAL,@C_SEMIACABADO_CDPRODINSUMO,@C_SEMIACABADO_CDPROCFABRIC,@P_TIPOCUSTO,@C_SEMIACABADO_QUANTIDADE,@P_DTCUSTO) * @C_SEMIACABADO_QUANTIDADE / ISNULL(@V_QTDE,1));
            END
            ELSE BEGIN
               SET @V_VRCUSTINSUMO = 0;

               SELECT
                  @V_VRCUSTINSUMO = (SUM(TEKNISA.QTPREVI_MATPRIMA(@P_CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, @C_SEMIACABADO_QUANTIDADE, 'S') *
                                     TEKNISA.CUSTO_PRODUTO(@P_CDFILIAL, I.CDPRODINSUMO, @P_TIPOCUSTO, @P_DTCUSTO, @P_DTCUSTO) / ISNULL(@C_SEMIACABADO_QUANTIDADE,1)))
               FROM
                  INSUMETAPA I
               WHERE
                  (I.CDFILIAL     = @P_CDFILIAL)                  AND
                  (I.CDPRODUTO    = @C_SEMIACABADO_CDPRODINSUMO)  AND
                  (I.CDPROCFABRIC = @C_SEMIACABADO_CDPROCFABRIC);

               SET @V_VRCUSTPROD = @V_VRCUSTPROD + @V_VRCUSTINSUMO;
            END;
            FETCH NEXT FROM C_SEMIACABADO INTO @C_SEMIACABADO_CDPRODUTO, @C_SEMIACABADO_CDPRODINSUMO,
                                               @C_SEMIACABADO_CDPROCFABRIC, @C_SEMIACABADO_IDPROFABPADR, @C_SEMIACABADO_QUANTIDADE;
         END; /* LOOP DOS SERVIOS */

         CLOSE C_SEMIACABADO;
         DEALLOCATE C_SEMIACABADO;
      END   
      ELSE BEGIN
         SET @V_VRCUSTINSUMO = 0;

         SELECT
            @V_VRCUSTINSUMO = (SUM(TEKNISA.QTPREVI_MATPRIMA(@P_CDFILIAL, I.CDPRODUTO, I.CDPROCFABRIC, I.CDETAPAPROD, I.CDPRODINSUMO, @P_QTDE, 'S') *
                               TEKNISA.CUSTO_PRODUTO(@P_CDFILIAL, I.CDPRODINSUMO, @P_TIPOCUSTO, @P_DTCUSTO, @P_DTCUSTO)) / ISNULL(@V_QTDE,1))
         FROM
            INSUMETAPA I
         WHERE
            (I.CDFILIAL     = @P_CDFILIAL)      AND
            (I.CDPRODUTO    = @P_CDPRODUTO)     AND
            (I.CDPROCFABRIC = @P_CDPROCFABRIC);

         SET @V_VRCUSTPROD = @V_VRCUSTINSUMO;
      END;
   END
   ELSE BEGIN
      /* Verifica matria-prima */
      SET @V_VRCUSTMPRIMA = 0;

      SELECT
         @V_VRCUSTMPRIMA = MAX(TEKNISA.CUSTO_PRODUTO(@P_CDFILIAL, @P_CDPRODUTO, @P_TIPOCUSTO, @P_DTCUSTO, @P_DTCUSTO));

      SET @V_VRCUSTPROD = @V_VRCUSTMPRIMA;
   END;

   RETURN(@V_VRCUSTPROD);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'CUSTO_MPRIMAINSUMO','4.09.083';
GO

