ALTER TABLE PARAVEND ADD IDAPURELRETESTQ VARCHAR2(1) DEFAULT 'N' NOT NULL
/

ALTER TABLE PARAVEND ADD CONSTRAINT CKC_IDAPURELRETESTQ_PARAVEND CHECK (IDAPURELRETESTQ IN ('S','N'))
/

CREATE TABLE ITLANCTOESTREL (
   CDFILIAL       VARCHAR2(4)  NOT NULL,
   NRLANCESTQ     VARCHAR2(10) NOT NULL,
   NRSEQUITEM     VARCHAR2(4)  NOT NULL,
   CDPRODUTO      VARCHAR2(10) NOT NULL,
   CDPRODMOVI     VARCHAR2(10) NOT NULL,
   QTLANCTOEST    FLOAT        NOT NULL,
   VRUNILANCTO    FLOAT        NULL,
   VRTOTLANCTO    FLOAT        NULL,
   VRLANCTOEST    FLOAT        NULL,
   VRLANCTOBRUT   FLOAT        NULL,
   QTTOTLANCTO    FLOAT        NULL,
   DTLANCMOVI     DATE         NOT NULL,
   CDFILIMOVI     VARCHAR2(4)  NOT NULL,
   CDPRODPAI      VARCHAR2(10) NOT NULL,
   QTPRODPAI      FLOAT        NOT NULL,
   QTRETIRAOBS    FLOAT        NULL,
   QTADICIONAOBS  FLOAT        NULL,
   NRORG          NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
   IDATIVO        VARCHAR2(1)  DEFAULT 'S' NOT NULL
      CONSTRAINT CKC_IDATIVO_ITLANCTOESTREL CHECK (IDATIVO IN ('S','N')),
   DTINCLUSAO     DATE         DEFAULT SYSDATE,
   DTULTATU       DATE         DEFAULT SYSDATE,
   NRORGINCLUSAO  NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1' NULL,
   NRORGULTATU    NUMBER       DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
   CDOPERULTATU   VARCHAR2(12) DEFAULT '1' NULL,
   CONSTRAINT PK_ITLANCTOESTREL PRIMARY KEY (CDFILIAL, NRLANCESTQ, NRSEQUITEM)
)
/

CREATE INDEX VND00821_FK ON ITLANCTOESTREL (CDFILIAL ASC, NRLANCESTQ ASC)
/

ALTER TABLE ITLANCTOESTREL
   ADD CONSTRAINT FKVND00821LANCTOESTOQ FOREIGN KEY (CDFILIAL, NRLANCESTQ)
      REFERENCES LANCTOESTOQ (CDFILIAL, NRLANCESTQ) ON DELETE CASCADE
/

CREATE INDEX VND00822_FK ON ITLANCTOESTREL (CDPRODUTO ASC)
/

ALTER TABLE ITLANCTOESTREL
   ADD CONSTRAINT FKVND00822PRODUTO FOREIGN KEY (CDPRODUTO)
      REFERENCES PRODUTO (CDPRODUTO)
/

CREATE INDEX VND00823_FK ON ITLANCTOESTREL (CDPRODMOVI ASC)
/

ALTER TABLE ITLANCTOESTREL
   ADD CONSTRAINT FKVND00823PRODUTO FOREIGN KEY (CDPRODMOVI)
      REFERENCES PRODUTO (CDPRODUTO)
/

CREATE INDEX VND00824_FK ON ITLANCTOESTREL (CDPRODPAI ASC)
/

ALTER TABLE ITLANCTOESTREL
   ADD CONSTRAINT FKVND00824PRODUTO FOREIGN KEY (CDPRODPAI)
      REFERENCES PRODUTO (CDPRODUTO)
/

CREATE INDEX VND00825_FK ON ITLANCTOESTREL (CDFILIMOVI ASC)
/

ALTER TABLE ITLANCTOESTREL
   ADD CONSTRAINT FKVND00825FILIAL FOREIGN KEY (CDFILIMOVI)
      REFERENCES FILIAL (CDFILIAL)
/

CREATE INDEX ITLANCTOESTREL_01 ON ITLANCTOESTREL (CDFILIMOVI ASC, DTLANCMOVI ASC, CDPRODUTO ASC)
/

CREATE INDEX ITLANCTOESTREL_02 ON ITLANCTOESTREL (CDFILIMOVI ASC, DTLANCMOVI ASC, CDPRODMOVI ASC)
/

CREATE INDEX ITLANCTOESTREL_03 ON ITLANCTOESTREL (CDFILIMOVI ASC, DTLANCMOVI ASC, CDPRODPAI ASC)
/