// FILE: ./assets/modules/saldos/assets/js/repositories/Ctb17000_Implantacao_Saldo_Repository.js
var Ctb17000_Implantacao_Saldo_Repository = function(restEngine){
    this.getMask = function(){
         return restEngine.post('ctb#/crud/paramgeral', {
              "requestType": "FilterData",
              "row": {}
         });
    };

    this.getSequencial = function(){
         return restEngine.post('ctb#/sequencialImplantSaldo', {
              "requestType": "Row",
              "row": {}
         });
    };

    this.salvar = function(row){
         return restEngine.post('ctb#/implantsaldo_empresa/save', {
              "requestType": "DataSet",
              "dataset": [row]
         });
    };
};


Configuration(function(ContextRegister) {
     ContextRegister.register('Ctb17000_Implantacao_Saldo_Repository', Ctb17000_Implantacao_Saldo_Repository);
});

// FILE: ./assets/modules/saldos/assets/js/repositories/Ctb68000_RecalculoSaldosGerenciais_Repository.js
function Ctb68000_RecalculoSaldosGerenciais_Repository(restEngine){
    
    this.recalcularSaldo = function(row){
        return restEngine.post("ctb_saldos#/recalculo_saldos_gerenciais/recalcularSaldo", {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.validatePeriodoContabil = function(row) {
        return restEngine.post("ctb_saldos#/recalculo_saldos_gerenciais/validatePeriodoContabil", {
            "requestType": "Row",
            "row": row
        });
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register("Ctb68000_RecalculoSaldosGerenciais_Repository", Ctb68000_RecalculoSaldosGerenciais_Repository);
});

// FILE: ./assets/modules/saldos/assets/js/repositories/Ctb72800_RecalculoSaldosComerciais_Repository.js
function Ctb72800_RecalculoSaldosComerciais_Repository(restEngine){
    
    this.recalcularSaldo = function(row){
        return restEngine.post("ctb_saldos#/recalculo_saldos_comerciais/recalcularSaldo", {
            "requestType": "Row",
            "row": row
        });
    };
    
    this.validatePeriodoContabil = function(row) {
        return restEngine.post("ctb_saldos#/recalculo_saldos_comerciais/validatePeriodoContabil", {
            "requestType": "Row",
            "row": row
        });
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register("Ctb72800_RecalculoSaldosComerciais_Repository", Ctb72800_RecalculoSaldosComerciais_Repository);
});

// FILE: ./assets/modules/saldos/assets/js/services/Ctb17000_Implantacao_Saldo_Service.js
var Ctb17000_Implantacao_Saldo_Service = function(Ctb17000_Implantacao_Saldo_Repository, ZHPromise){
    this.getMask = function(){
        return Ctb17000_Implantacao_Saldo_Repository.getMask();
    };
    
    this.getSequencial = function(){
        return Ctb17000_Implantacao_Saldo_Repository.getSequencial();
    };
    
    this.salvar = function(row){
        return Ctb17000_Implantacao_Saldo_Repository.salvar(row).then(function(row){
            return row;
        });
    };
};

Configuration(function(ContextRegister) {
     ContextRegister.register('Ctb17000_Implantacao_Saldo_Service', Ctb17000_Implantacao_Saldo_Service);
});

// FILE: ./assets/modules/saldos/assets/js/services/Ctb68000_RecalculoSaldosGerenciais_Service.js
function Ctb68000_RecalculoSaldosGerenciais_Service(ErrorFrontend, Ctb68000_RecalculoSaldosGerenciais_Repository){
    
    function checkSaldoRow(row){
        if(isEmpty(row.CDEMPRESA)){
            return ErrorFrontend.regectedPromiseFieldEmpty('CDEMPRESA');
        }
        else{
            if(isEmpty(row.DTSALDO)){
                return ErrorFrontend.regectedPromiseFieldEmpty('DTSALDO');
            }
        }
        return null;
    }
    
    function isEmpty(value){
        return (value === undefined || value === null);
    }
    
    this.recalcularSaldo = function(row){
        var promise = checkSaldoRow(row);
        if(promise === null){
            return Ctb68000_RecalculoSaldosGerenciais_Repository.recalcularSaldo(row);
        }
        else{
            return promise;
        }
    };
    
    this.validatePeriodoContabil = function(row){
        var promise = checkSaldoRow(row);
        if(promise === null){
            return Ctb68000_RecalculoSaldosGerenciais_Repository.validatePeriodoContabil(row);
        }
        else{
            return promise;
        }
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register("Ctb68000_RecalculoSaldosGerenciais_Service", Ctb68000_RecalculoSaldosGerenciais_Service);
});

// FILE: ./assets/modules/saldos/assets/js/services/Ctb72800_RecalculoSaldosComerciais_Service.js
function Ctb72800_RecalculoSaldosComerciais_Service(ErrorFrontend, Ctb72800_RecalculoSaldosComerciais_Repository){
    
    function checkSaldoRow(row){
        if(isEmpty(row.CDEMPRESA)){
            return ErrorFrontend.regectedPromiseFieldEmpty('CDEMPRESA');
        }
        else{
            if(isEmpty(row.DTSALDO)){
                return ErrorFrontend.regectedPromiseFieldEmpty('DTSALDO');
            }
        }
        return null;
    }
    
    function isEmpty(value){
        return (value === undefined || value === null);
    }
    
    this.recalcularSaldo = function(row){
        var promise = checkSaldoRow(row);
        if(promise === null){
            return Ctb72800_RecalculoSaldosComerciais_Repository.recalcularSaldo(row);
        }
        else{
            return promise;
        }
    };
    
    this.validatePeriodoContabil = function(row){
        var promise = checkSaldoRow(row);
        if(promise === null){
            return Ctb72800_RecalculoSaldosComerciais_Repository.validatePeriodoContabil(row);
        }
        else{
            return promise;
        }
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register("Ctb72800_RecalculoSaldosComerciais_Service", Ctb72800_RecalculoSaldosComerciais_Service);
});

// FILE: ./assets/modules/saldos/assets/js/controllers/Ctb13000_RecalculoSaldoFiscal_Controller.js
var Ctb13000_RecalculoSaldoFiscal_Controller = function(ScreenService, General) {

    // Armazena a máscar de conta contábil retornada da PARAMGERAL.
    var contctblMask;

    /*
     * Função chamada por máscaras dos campos de conta contábil.
     * Retorna a máscara de conta contábil setada previamente na variável.
     */
    this.getContctblMask = function() {
        return contctblMask;
    };

    this.recalcularSaldoFiscal = function(recalculoWidget) {
        // Verifica se todos os campos obrigatórios foram preenchidos.
        if (recalculoWidget.isValid()) {
            var currentRow = recalculoWidget.currentRow;
            // Verifica se a conta final é igual ou maior do que a conta inicial.
            if (currentRow.CDCONTCTBLFIN < currentRow.CDCONTCTBLINI) {
                ScreenService.showMessage("Conta inicial deve ser menor ou igual à conta final.");
                return;
            }

            // Verifica se a data final foi preenchida, setando o valor NULL caso contrário.
            currentRow.DTFINAL = currentRow.DTFINAL ? currentRow.DTFINAL : null;

            // Verifica se a data final foi preenchida e é igual ou maior do que a data inicial.
            if (currentRow.DTFINAL !== null && moment(currentRow.DTFINAL, 'DD/MM/YYYY').isBefore(moment(currentRow.DTINICIAL, 'DD/MM/YYYY'))) {
                ScreenService.showMessage("A Data Final, quando informada, deve ser maior ou igual à data inicial informada.");
                return;
            }

            // Muda a mensagem de carregamento para uma mensagem personalizada.
            ScreenService.changeLoadingMessage("Recalculando os saldos...");

            // Chama a rota para efetuar a rotina de recálculo.
            General.callRestEngine("ctb#/recalculoSaldoFiscal", "Row", currentRow)
            .then(function() {
                ScreenService.showMessage("O recálculo de saldo fiscal foi realizado com sucesso.");
            })
            .catch(function(error) {
                // Mensagem padrão em caso de timeout.
                var errorMessage = 'Timeout';

                // Verifica se houve alguma resposta da requisição.
                if (error.data) {
                    // Caso haja alguma resposta, atribui a mensagem de erro.
                    errorMessage = error.data.error;
                }

                // Imprime a mensagem.
                ScreenService.showMessage(errorMessage);
            })
            .finally(function() {
                // Restaura a mensagem original.
                ScreenService.restoreDefaultLoadingMessage();
            });
        }
    };

    /*
     * Função chamada pela tela ao ser aberta.
     * Seta a máscara de conta contábil buscada da PARAMGERAL na variável.
     */
    this.setContctblMask = function() {
        // Chama a rota que retorna os dados da PARAMGERAL.
        General.callRestEngine("ctb#/crud/paramgeral", "FilterData", []).then(function(response) {
            // Busca o primeiro dado retornado, que será o único registro da parametrização.
            var paramgeral = response.dataset.paramgeral[0];

            // Armazena o valor da máscara na variável.
            contctblMask = paramgeral.CDPICTCCTB;
        });
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Ctb13000_RecalculoSaldoFiscal_Controller', Ctb13000_RecalculoSaldoFiscal_Controller);
});

// FILE: ./assets/modules/saldos/assets/js/controllers/Ctb17000_Implantacao_Saldo_Controller.js
var Ctb17000_Implantacao_Saldo_Controller = function(Ctb17000_Implantacao_Saldo_Service, General, ScreenService, templateManager, Messages_Contabil){

    this.edit = function(widget){
        General.edit(widget);
        this.setDadosSaldo(widget);
    };
    
    this.new = function(widget){
        widget.newRow();
        this.setDadosSaldo(widget);
    };

    this.setMask = function(widget){
         Ctb17000_Implantacao_Saldo_Service.getMask().then(function(success){
           var stMask = success.dataset.paramgeral[0].CDPICTCCTB;
            var mask = {
                "type": "fix",
                "params": {
                    "mask": stMask
                }
            };

            /* Atualiza a máscara da tela principal */
            widget.getField('NMCONTCTBLINI').fields[0].mask = mask;
            widget.getField('NMCONTCTBLFIN').fields[0].mask = mask;
            widget.getField('NMCONTCTBL').fields[0].mask = mask;
        });
     };

   this.ultimoDia = function(widget){
       var dtImpSaldo = widget.currentRow.DTSALDO;
        if (dtImpSaldo) {
            dtImpSaldo = moment(dtImpSaldo, "DD/MM/YYYY");
            dtImpSaldo = dtImpSaldo.endOf("month").format("DD/MM/YYYY");
            widget.currentRow.DTSALDO = dtImpSaldo;
        }
   };

   this.setSequencial = function (widget){
       Ctb17000_Implantacao_Saldo_Service.getSequencial().then(function (retorno) {
            var inSequencial = retorno.dataset.dataSetSequencial.NRSEQUENCIAL;
            widget.currentRow.NRIMPLSALDO = inSequencial;
            this.setDadosSaldo(widget);
        }.bind(this), function (error) {
            ScreenService.showMessage(error.data.error);
        });
   };

   this.setDadosSaldo = function(widget){
       widget.currentRow.CDEMPRESA = widget.appliedFilter.FILTER_ROW.CDEMPRESA;
       widget.currentRow.NMRAZSOCEMPR = widget.appliedFilter.FILTER_ROW.NMRAZSOCEMPR;
       widget.currentRow.DTSALDO = widget.appliedFilter.FILTER_ROW.DTSALDO;
       widget.currentRow.DTIMPSALDO = widget.currentRow.DTSALDO;
   };
   
    this.salvar = function(widget) {
        if (widget.isValid()) {
            widget.currentRow.__columns_to_return = widget.__columns_to_return;
            Ctb17000_Implantacao_Saldo_Service.salvar(widget.currentRow).then(function(retorno){
                ScreenService.showMessage(Messages_Contabil.CADASTRADO_COM_SUCESSO);
                widget.view();
                if(widget.currentRow.__is_new){
                    widget.currentRow.__is_new = false;
                    widget.currentRow.NRORG = retorno.dataset.columnsToReturn.NRORG;
                }
            }, function(error){
                if (error.data.error === 'JA_CADASTRADO'){
                    ScreenService.showMessage(Messages_Contabil.SALDO_JA_IMPLANTADO);
                } else{
                    ScreenService.showMessage(error.data.error);
                }
            });
        }
    };
};

Configuration(function(ContextRegister) {
     ContextRegister.register('Ctb17000_Implantacao_Saldo_Controller', Ctb17000_Implantacao_Saldo_Controller);
});

// FILE: ./assets/modules/saldos/assets/js/controllers/Ctb22000_RazaoOficial_Controller.js
var Ctb22000_RazaoOficial_Controller = function(ScreenService, General) {

    this.preparaFiltroRazaoOficial = function(widget, preference){
        var filtro = preference.FILTER_ROW;
        var i = 0;
        var posData = [];
        widget.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDEMPRESA': filter.value = filtro.CDEMPRESA;
                    break;
                case 'CDCONTCTBLINI': filter.value = filtro.CDCONTCTBLINI;
                    break;
                case 'CDCONTCTBLFIN': filter.value = filtro.CDCONTCTBLFIN;
                    break;
                case 'DTINICIAL': filter.value = filtro.DTLANCCONT.start;
                    break;
                case 'DTFINAL': filter.value = filtro.DTLANCCONT.end;
                    break;
                case 'DTLANCCONT': posData.push(i);
                    break;
                case 'NMEMPRESA': posData.push(i);
                    break;
                case 'NMCONTCTBLINI': posData.push(i);
                    break;
                case 'NMCONTCTBLFIN': posData.push(i);
                    break;
                
            }
            i++;
        });
        posData.sort();
        var qtde = posData.length;
        for (var j = 1; qtde > j; j++){
            widget.dataSourceFilter.splice(posData[qtde - j], 1);
        }
    };
    
    /*
     * Função chamada pela tela ao ser aberta.
     * Seta a máscara de conta contábil buscada da PARAMGERAL na variável.
     */
    this.setContctblMask = function() {
        // Chama a rota que retorna os dados da PARAMGERAL.
        General.callRestEngine("ctb#/crud/paramgeral", "FilterData", []).then(function(response) {
            // Busca o primeiro dado retornado, que será o único registro da parametrização.
            var paramgeral = response.dataset.paramgeral[0];

            // Armazena o valor da máscara na variável.
            contctblMask = paramgeral.CDPICTCCTB;
        });
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Ctb22000_RazaoOficial_Controller', Ctb22000_RazaoOficial_Controller);
});

// FILE: ./assets/modules/saldos/assets/js/controllers/Ctb22100_RazaoGerencial_Controller.js
var Ctb22100_RazaoGerencial_Controller = function(ScreenService, General, templateManager) {

    var contctblMask = "";

    this.setContctblMask = function() {
        General.callRestEngine("ctb#/crud/paramgeral", "FilterData", []).then(function(response) {
            var paramgeral = response.dataset.paramgeral[0];

            contctblMask = paramgeral.CDPICTCCTB;
        });
    };

    this.getContctblMask = function() {
        return contctblMask;
    };

    this.preparaFiltroRazaoGerencial = function(args) {
    	var widget    = templateManager.container.getWidget('RazaoGerencialGrid');
    	var filterRow = args.e.preference.FILTER_ROW;
    	
    	args.e.preference.FILTER_ROW = {};
    	args.e.preference.CUSTOM_FILTER_ROW = {};
    	
    	General.callRestEngine('ctb#/geraRazaoGerencial', 'Row', filterRow).then(function (response) {
    		var nrctbtemp = response.dataset.ctbtemp[0];
    		
    		var filtro = [
    			{
    				"name": "NRCTBTEMP",
    				"operator": "=",
    				"value": nrctbtemp
    			}
    		];
    		
    		args.e.preference.FILTER_ROW = {"NRCTBTEMP" : nrctbtemp};
    		widget.dataSourceFilter = filtro;
    		widget.reload();
    	}).catch(function(erro){
    		ScreenService.showMessage(erro.data.error);
    	});
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Ctb22100_RazaoGerencial_Controller', Ctb22100_RazaoGerencial_Controller);
});

// FILE: ./assets/modules/saldos/assets/js/controllers/Ctb68000_RecalculoSaldosGerenciais_Controller.js
function Ctb68000_RecalculoSaldosGerenciais_Controller(ScreenService, Ctb68000_RecalculoSaldosGerenciais_Service){
    
    var messages = {
        DATA_INICIO_FORA_PERIODO_CONTABIL :  "Data início deve estar dentro do período contábil.",
        REQUEST_SUCCESS: 'Operação realizada com sucesso.',
        DATA_NAO_POSSUI_MES: 'Data Passada não possui mês.'
    };
    
    var paramMessages = {
        CAMPO_VAZIO : function(params){
            var message = 'O campo ? está vazio.';
            return message.replace('?', fieldNames[params[0]]);
        }
    };
    
     var fieldNames = {
            CDEMPRESA : 'Empresa',
            DTSALDO: 'Data início'
        };
    
    function message(messageCode, params){
        if(params === undefined){
            return messages[messageCode];
        }
        else{
            return  paramMessages[messageCode](params);
        }
    }
    
    function requestSuccess(){
        return function(response){
            var messageCode = 'REQUEST_SUCCESS';
            ScreenService.showMessage(message(messageCode), 'SUCCESS');
        };
    }
    
    function requestError(){
        return function(response){
            var errorMessage = 'Timeout';
			if (response.data){
				errorMessage = message(response.data.error, response.data.messageParams);
			}
            ScreenService.showMessage(errorMessage);
        };
    }
    
    function rowValidForValidatePeriodoContabil(row){
        return (row.CDEMPRESA && row.DTSALDO);
    }
    
    this.recalcularSaldo = function(widget){
        if(widget.isValid()){
            Ctb68000_RecalculoSaldosGerenciais_Service.recalcularSaldo(widget.currentRow).then(
                requestSuccess(),
                requestError()
            );
        }
    };
    
    this.validatePeriodoContabil = function(currentRow){
        if(rowValidForValidatePeriodoContabil(currentRow)){
            Ctb68000_RecalculoSaldosGerenciais_Service.validatePeriodoContabil(currentRow).then(
                function(success){},
                requestError()
            );
        }
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register("Ctb68000_RecalculoSaldosGerenciais_Controller", Ctb68000_RecalculoSaldosGerenciais_Controller);
});

// FILE: ./assets/modules/saldos/assets/js/controllers/Ctb72800_RecalculoSaldosComerciais_Controller.js
function Ctb72800_RecalculoSaldosComerciais_Controller(ScreenService, Ctb72800_RecalculoSaldosComerciais_Service){
    
    var messages = {
        DATA_INICIO_FORA_PERIODO_CONTABIL :  "Data início deve estar dentro do período contábil.",
        REQUEST_SUCCESS: 'Operação realizada com sucesso.',
        DATA_NAO_POSSUI_MES: 'Data Passada não possui mês.'
    };
    
    var paramMessages = {
        CAMPO_VAZIO : function(params){
            var message = 'O campo ? está vazio.';
            return message.replace('?', fieldNames[params[0]]);
        }
    };
    
     var fieldNames = {
            CDEMPRESA : 'Empresa',
            DTSALDO: 'Data início'
        };
    
    function message(messageCode, params){
        if(params === undefined){
            return messages[messageCode];
        }
        else{
            return  paramMessages[messageCode](params);
        }
    }
    
    function requestSuccess(){
        return function(response){
            var messageCode = 'REQUEST_SUCCESS';
            ScreenService.showMessage(message(messageCode), 'SUCCESS');
        };
    }
    
    function requestError(){
        return function(response){
            var errorMessage = 'Timeout';
			if (response.data){
				errorMessage = message(response.data.error, response.data.messageParams);
			}
            ScreenService.showMessage(errorMessage);
        };
    }
    
    function rowValidForValidatePeriodoContabil(row){
        return (row.CDEMPRESA && row.DTSALDO);
    }
    
    this.recalcularSaldo = function(widget){
        if(widget.isValid()){
            Ctb72800_RecalculoSaldosComerciais_Service.recalcularSaldo(widget.currentRow).then(
                requestSuccess(),
                requestError()
            );
        }
    };
    
    this.validatePeriodoContabil = function(currentRow){
        if(rowValidForValidatePeriodoContabil(currentRow)){
            Ctb72800_RecalculoSaldosComerciais_Service.validatePeriodoContabil(currentRow).then(
                function(success){},
                requestError()
            );
        }
    };
    
}
Configuration(function(ContextRegister) {
    ContextRegister.register("Ctb72800_RecalculoSaldosComerciais_Controller", Ctb72800_RecalculoSaldosComerciais_Controller);
});
